// ClientFileUser.h: interface for the ClientFileUser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLIENTFILEUSER_H__EA35F47C_FFE6_4310_B62F_112BC8829AAB__INCLUDED_)
#define AFX_CLIENTFILEUSER_H__EA35F47C_FFE6_4310_B62F_112BC8829AAB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* This ClientUser subclass handles "p4 files" and "p4 filelog" commands.  See ClientDepotUser for
 * more detailed comments on the way in which these ClientUser subclasses are used. */

class ClientFileUser : public ClientUser
{
public:
	/*OutputInfo() handles "p4 files" output by default.*/
	void OutputInfo(char, const_char*);
	/*OutputLog() handles "p4 filelog" output - it is called if logflag is set.*/
	void OutputLog(char, const_char*);
	ClientFileUser();
	virtual ~ClientFileUser();

	bool logflag; //Set this to handle "p4 filelog" output.
	short results;
	ListList files; //List of file paths in StrBuf form.
	ListList ftypes; //List of file types of the files in "files".
	StrBuf filelog; //StrBuf containing filelog output.

	int maxresults;
};

#endif // !defined(AFX_CLIENTFILEUSER_H__EA35F47C_FFE6_4310_B62F_112BC8829AAB__INCLUDED_)
